#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll N = 1e6;
ll t[N * 4];

void upd(ll v, int l, int r, int pos, int x) {
    if (pos < l || r <= pos) {
        return;
    }
    if (l + 1 == r) {
        t[v] = x;
        return;
    }
    int mid = (l + r) / 2;
    upd (2 * v, l, mid, pos, x);
    upd (2 * v + 1, mid, r, pos, x);
    t[v] = min (t[2 * v], t[2 * v + 1]);
}

ll getmin(ll v, int l, int r, int L, int R) {
    if (L == R) {
        return 1e18;
    }
    if (r <= L || R <= l) {
        return 1e18;
    }
    if (L <= l && r <= R) {
        return t[v];
    }
    int mid = (l + r) / 2;
    return min(getmin (2 * v, l, mid, L, R), getmin (2 * v + 1, mid, r, L, R));
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n, k;
    cin >> n >> k;
    ll a[n + 1], s = 0, w = 0;
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
        upd(1, 0, n, i, a[i]);
        s += a[i];
        if (i <= n - k) {
            w += a[i];
        }
    }
    ll ans = 0;
    for (ll i = 0; i < k; i++) {
        ans = max (ans, w - min(getmin (1, 0, n, n - k + 1 + i, n - i), getmin (1, 0, n, 0, i)));
        w -= a[i];
        w += a[n - k + 1 + i];
    }
    cout << ans << '\n';
    return 0;
}